"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var linked_list_1 = require("./linked-list");
var Event = /** @class */ (function () {
    function Event() {
    }
    Event.prototype.call = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        linked_list_1.forEachItem(this.listeners, function (callback) { return callback.apply(void 0, args); });
    };
    Event.prototype.follow = function (callback) {
        var _this = this;
        var item = linked_list_1.createList(callback);
        if (this.listeners === undefined) {
            this.listeners = item;
        }
        else {
            linked_list_1.insertItemAfter(this.listeners, item);
        }
        return function () {
            if (item === _this.listeners) {
                _this.listeners = _this.listeners.next;
            }
            else {
                linked_list_1.removeItem(item);
            }
        };
    };
    Event.prototype.dispose = function () {
        linked_list_1.disposeList(this.listeners);
        delete this.listeners;
    };
    return Event;
}());
exports.Event = Event;
