export interface LinkedList<Type> {
    value: Type;
    prev?: LinkedList<Type>;
    next?: LinkedList<Type>;
}
export declare function createList<Type>(value: Type): LinkedList<Type>;
export declare function insertItemAfter<Type>(item: LinkedList<Type>, newItem: LinkedList<Type>): void;
export declare function removeItem<Type>(item: LinkedList<Type>): void;
export declare function forEachItem<Type>(list: LinkedList<Type> | undefined, callback: (value: Type) => void): void;
export declare function disposeList<Type>(list: LinkedList<Type> | undefined): void;
