"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createList(value) {
    return { value: value };
}
exports.createList = createList;
function insertItemAfter(item, newItem) {
    var next = item.next;
    item.next = newItem;
    newItem.prev = item;
    if (next) {
        newItem.next = next;
        next.prev = newItem;
    }
}
exports.insertItemAfter = insertItemAfter;
function removeItem(item) {
    var prev = item.prev;
    var next = item.next;
    if (prev !== undefined) {
        prev.next = next;
    }
    if (next !== undefined) {
        next.prev = prev;
    }
    item.next = undefined;
    item.prev = undefined;
}
exports.removeItem = removeItem;
function forEachItem(list, callback) {
    var currentItem = list;
    while (currentItem !== undefined) {
        callback(currentItem.value);
        currentItem = currentItem.next;
    }
}
exports.forEachItem = forEachItem;
function disposeList(list) {
    var currentItem = list;
    while (currentItem !== undefined) {
        var nextItem = currentItem.next;
        currentItem.prev = undefined;
        currentItem.next = undefined;
        currentItem = nextItem;
    }
}
exports.disposeList = disposeList;
