"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var signal_1 = require("./signal");
var getValues = function (sources) {
    var values = {};
    Object.keys(sources).forEach(function (key) {
        var source = sources[key];
        values[key] = source instanceof signal_1.Signal ? source.get() : source;
    });
    return values;
};
var MergedSignal = /** @class */ (function (_super) {
    __extends(MergedSignal, _super);
    function MergedSignal(sources, combine) {
        var _this = _super.call(this, combine(getValues(sources))) || this;
        _this.bindings = Object.keys(sources).map(function (key) {
            return sources[key].follow(function (value) {
                var values = getValues(sources);
                values[key] = value;
                _super.prototype.set.call(_this, combine(values));
            });
        });
        return _this;
    }
    MergedSignal.prototype.set = function (_) {
        throw new Error('Cannot set value');
    };
    MergedSignal.prototype.dispose = function () {
        this.bindings.forEach(function (unbind) { return unbind(); });
        _super.prototype.dispose.call(this);
    };
    return MergedSignal;
}(signal_1.Signal));
exports.MergedSignal = MergedSignal;
