"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var event_1 = require("./event");
var Signal = /** @class */ (function () {
    function Signal(initial) {
        this.latest = initial;
        this.event = new event_1.Event();
    }
    Signal.prototype.set = function (value) {
        if (value !== this.latest) {
            this.latest = value;
            this.event.call(value);
        }
    };
    Signal.prototype.get = function () {
        return this.latest;
    };
    Signal.prototype.follow = function (callback, runNow) {
        if (runNow === void 0) { runNow = false; }
        if (runNow) {
            callback(this.latest);
        }
        return this.event.follow(callback);
    };
    Signal.prototype.dispose = function () {
        this.event.dispose();
    };
    return Signal;
}());
exports.Signal = Signal;
